#include <vector>
#include "Student_info.h"
#include "grade.h"

#include <iostream>

//#define SWITCH_erase

using std::vector;

vector<Student_info> extract_fails(vector<Student_info>& students)
{
#ifndef SWITCH_erase
	// Lsungsansatz 1: Nicht funktionsfhig, Problem mit Iterator
	/*vector<Student_info>::iterator iter = students.begin();
	vector<Student_info> fail;
	vector<Student_info>::size_type numberofstundents = students.size();
	while (iter != students.end()) {
		if (fgrade(*iter)) {
			fail.push_back(*iter);
		} else {
			// Hier wird der Iterator ungltig
			students.insert(students.begin(),*iter);
			++iter;
		}
		++iter;
	}
	students.resize(numberofstundents - fail.size());*/
	// Lsungsansatz 1a: Funktioniert
	vector<Student_info> fail;
	vector<Student_info>::size_type numberofstundents = students.size();
	for (unsigned int counter = 0; counter != students.size(); counter++) {
		if (fgrade(students[counter])) {
			fail.push_back(students[counter]);
		} else {
			students.insert(students.begin(),students[counter]);
			++counter;
		}
	}
	students.resize(numberofstundents - fail.size());
	// Lsungsansatz 2: Mit partition, funktioniert
	/*vector<Student_info>::iterator iter_end = partition(students.begin(),students.end(),fgrade);
	vector<Student_info> fail(iter_end, students.end());
	students.erase(iter_end,students.end());*/
#endif

#ifdef SWITCH_erase
	vector<Student_info>::iterator iter = students.begin();
	vector<Student_info> fail;
	while (iter != students.end()) {
		if (fgrade(*iter)) {
			fail.push_back(*iter);
			iter = students.erase(iter);
		} else
			++iter;
	}
#endif

	return fail;
}


